<?php
/**
*
* @package phpBB3
* @version $Id: functions_quiz.php
* @copyright (c) 2008 battye, CricketMX.com
* Ultimate Quiz MOD v2.0.0
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

function check_quiz_edit_status($edit_own, $author_id, $user_id)
{
global $auth;

		if( !$auth->acl_get('a_') && $edit_own && ($author_id != $user_id) )
		{
			trigger_error($user->lang['QUIZ_USER_EDIT_OWN']);
		}
}

function get_author_of_quiz($quiz_id)
{
global $db;

	$sql 	= "SELECT quiz_author 
			   FROM " . QUIZ_TABLE . " WHERE quiz_id = " . intval($quiz_id);
	$result = $db->sql_query($sql);
	
	$author = $db->sql_fetchfield('quiz_author');
	$db->sql_freeresult($result);

return $author;
}

function get_category_name($cat_id)
{
global $db;

	$sql 	= "SELECT quiz_category_name FROM " . QUIZ_CATEGORY_TABLE . " WHERE quiz_category_id = " . intval($cat_id);
	$result = $db->sql_query($sql);
	
	$category_name 	= $db->sql_fetchfield('quiz_category_name');
	$db->sql_freeresult($result);

return $category_name;
}

function find_number_of_quiz_in_category($category_id)
{
global $db;

	$sql = "SELECT COUNT(quiz_id) as cat_count FROM " . QUIZ_TABLE . " WHERE quiz_category = " . intval($category_id);
	$result = $db->sql_query($sql);

	$cat_count = $db->sql_fetchfield('cat_count');
	$db->sql_freeresult($result);

return $cat_count;
}

function quiz_category_list($auto_id)
{
global $db, $user;

	$sql = "SELECT quiz_category_id, quiz_category_name FROM " . QUIZ_CATEGORY_TABLE . "
			ORDER BY quiz_category_name ASC";
	$result = $db->sql_query($sql);

	$dropdown_box = '<select name="select_category">';
	$dropdown_box .= '	<option value="undefined">' . $user->lang['SELECT_A_CATEGORY'] . '...</option>';

	while ($row = $db->sql_fetchrow($result))
	{
	$selected = '';

		if ($auto_id && ($auto_id == $row['quiz_category_id']))
		{
			$selected = ' selected';
		}

		$dropdown_box .= '	<option' . $selected . ' value="' . $row['quiz_category_id'] . '">' . $row['quiz_category_name'] . '</option>';
	}

	$dropdown_box .= '</select>';

return $dropdown_box;
}

function quiz_latest_id()
{
global $db;

	$sql = "SELECT quiz_id FROM " . QUIZ_TABLE . "
			ORDER BY quiz_id DESC
			LIMIT 1";
	$result = $db->sql_query($sql);

	$latest_quiz_id = $db->sql_fetchfield('quiz_id');
	$db->sql_freeresult($result);

return $latest_quiz_id;
}

function get_quiz_title($quiz_id)
{
global $db;

	$sql = "SELECT quiz_name FROM " . QUIZ_TABLE . "
			WHERE quiz_id = " . intval($quiz_id);
	$result = $db->sql_query($sql);

	$quiz_name = $db->sql_fetchfield('quiz_name');
	$db->sql_freeresult($result);

return $quiz_name;
}

/*********************** 
* Some explanation about this function
* If $type = 1, then it is to find the correct answer for a particular question_id
* If $type = 2, then it is to find whichever answer a specified data_id has
***********************/
function correct_answer_for_id($data_id, $type)
{
global $db;

	if ($type == 2)
	{
	$sql = "SELECT * FROM " . QUIZ_DATA_TABLE . "
			WHERE quiz_data_id = " . intval($data_id) . "
			LIMIT 1";
	}

	if ($type == 1)
	{
	$sql = "SELECT * FROM " . QUIZ_DATA_TABLE . "
			WHERE quiz_question_id = " . intval($data_id) . "
			AND quiz_correct = 1
			LIMIT 1";
	}

	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$correct_answer = generate_text_for_display($row['quiz_answer'], $row['quiz_uid'], $row['quiz_bitfield'], $row['quiz_options']);
	$db->sql_freeresult($result);

return $correct_answer;
}

function find_number_of_questions_in_quiz($quiz_id)
{
global $db;

	$sql = "SELECT quiz_number_of_questions
			FROM " . QUIZ_TABLE . "
			WHERE quiz_id = " . intval($quiz_id);
	$result = $db->sql_query($sql);

	$quiz_number = $db->sql_fetchfield('quiz_number_of_questions');
	$db->sql_freeresult($result);

return $quiz_number;
}

function find_current_live_progress_id($quiz_id, $type)
{
global $db, $user;

	$sql = "SELECT quiz_progress_id, quiz_progress_time, quiz_time_used 
			FROM " . QUIZ_PROGRESSIVE_TABLE . "
				WHERE quiz_player_id = '" . $user->data['user_id'] . "'
					AND quiz_id = " . intval($quiz_id) . "
			ORDER BY quiz_progress_id DESC
			LIMIT 1";

	$result = $db->sql_query($sql);

	$row = $db->sql_fetchrow($result);

	$progressive_id 		= $row['quiz_progress_id'];
	$progressive_time 		= $row['quiz_progress_time'];
	$progressive_time_used 	= $row['quiz_time_used'];

	$db->sql_freeresult($result);

	if ($type == 2)
	{
		$return_field = $progressive_time;
	}

	else if ($type == 3)
	{
		$return_field = $progressive_time_used;
	}

	else
	{
		$return_field = $progressive_id;
	}

return $return_field;
}
?>