<?php
/** 
*
* Ultimate Quiz MOD [English]
*
* @package language
* @version $Id: quiz.php, battye (c) 2004, 2005, 2008
* @copyright (c) 2008 battye, CricketMX.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(
	'QUIZ' => 'Quiz',	
	'QUIZ_EXPLAIN' => 'Ultimate Quiz MOD',

	// Various
	'QUIZ_MUST_BE_LOGGED_IN' 		=> 'You must be registered and logged in to view this page.',
	'QUIZ_MUST_ADMIN_USER' 			=> 'Only administrators can access this page.',
	'QUIZ_USER_EDIT_OWN'			=> 'As a user you are only permitted to edit your own quizzes',

	// Functions
	'SELECT_A_CATEGORY'				=> 'Select a category',
	'SELECT_A_CATEGORY_EXPLAIN'		=> 'Select a category which best matches the genre of the quiz.',
	
	// Submit quiz
	'SELECT_NUMBER'					=> 'Number of questions',
	'SELECT_NUMBER_EXPLAIN'			=> 'You may enter between <strong>%1$s</strong> and <strong>%2$s</strong> questions in this quiz. How many questions would you like to include?',

	'SUBMIT_STEP_1'					=> 'Step 1 of 3 - Enter your quiz!',
	'SUBMIT_STEP_2'					=> 'Step 2 of 3 - Enter the answers!',
	'SUBMIT_STEP_3'					=> 'Step 3 of 3 - Check all is correct!',

	'SUBMIT_QUIZ' 					=> 'Submit quiz',
	'SELECT_QUIZ_NAME' 				=> 'Select a name for this quiz',
	'SELECT_QUIZ_NAME_EXPLAIN'		=> 'This is the name that will appear in the list of quizzes. Choose a name that is short but still gives readers an understanding of what the quiz is about.',
	'ENTER_QUESTION'				=> 'Enter your question',
	'IS_TRUE_FALSE'					=> 'True or false question',
	'MULTIPLE_CHOICE_QUESTION'		=> 'Multiple choice question',
	'INPUT_ANSWER_QUESTION'			=> 'Input answer question',
	'MULTIPLES_REVEAL'				=> 'Alternates',
	'NOT_TRUE_FALSE'				=> 'Separate multiple choices by adding each option on a new line. For an input only quiz, enter just one line of text.',
	'SUBMIT_INFORMATION'			=> 'Enter questions in each of the %1$s fields provided below. For true and false questions, click the checkbox to demonstrate this - there is no need to type in the box below it. When entering input answer quizzes, simply type the answer into the large box provided. For multiple choices you must provide %2$s alternatives, by putting each on a new line. You will be prompted to select the correct answer for each question after you submit this page.',
	'VERIFY_SUBMIT_INFORMATION' 	=> 'For multiple choice answers, select the answer which is correct by clicking the box to the left of the correct answer. For true and false answers, select either true or false. Input answers do not need to be verified, they will be submitted as is.',
	'FINAL_VERIFY_SUBMIT'			=> 'Please check all your entries, if they are correct, click on Submit below.',
	'TRUE_FALSE_TRUE'				=> 'True',
	'TRUE_FALSE_FALSE'				=> 'False',
	'CORRECT_ANSWER'				=> 'Correct answer',
	'QUIZ_SUBMISSION_SUCCESSFUL'	=> 'Your quiz was successfully entered into the database.<br /><br />%sReturn to the quiz index page.%s',

	'OUTSIDE_QUESTION_PARAM'		=> 'You have not chosen a number between <strong>%1$d</strong> and <strong>%2$d</strong>, go back and try again.',
	'NUMBER_QUESTIONS_UNDEFINED'	=> 'The number of questions in this quiz is undefined, please return to the previous page and rectify this.',
	'TOO_MANY_CHOICES'				=> 'One or more of your multiple choice questions has <strong>more than %s</strong> choices! Please remove any excess choices.<br /><br />',
	'EMPTY_QUESTION'				=> 'You have left one or more question fields empty! Click the back button in your browser to return to the previous page, and ensure no fields are left empty.',
	'EMPTY_ANSWER'					=> 'You have left one or more answer fields empty. Click the back button in your browser to return to the previous page, and ensure no fields are left empty.',
	'EMPTY_QUIZ_FIELDS'				=> 'You have left some fields empty! Please make sure each field is filled out correctly.',
	'EMPTY_RADIO_BOX'				=> 'You haven\'t selected one or more radio boxes, meaning you still need to select a multiple choice and/or true/false answer, <strong>or</strong> you have not yet filled in the quiz name and category.',

	// Index
	'QUIZ_PASSWORD_PROTECTED_CAT'	=> 'A password is required to access this category',
	'VIEW_QUIZ_CATEGORIES'			=> 'Select a category',
	'NUMBER_OF_QUIZ_INDEX_SINGLE'	=> '%d quiz',
	'NUMBER_OF_QUIZ_INDEX_PLURAL'	=> '%d quizzes',
	'NUMBER_OF_QUIZ_VIEWS_SINGLE'	=> '%d view',
	'NUMBER_OF_QUIZ_VIEWS_PLURAL'	=> '%d views',
	'QUIZ_NAME'						=> 'Quiz name',
	'QUIZ_AUTHOR'					=> 'Author',
	'QUIZ_DATE'						=> 'Submission date',
	'QUIZ_VIEWS'					=> 'Views',
	'QUIZ_IN_PROGRESS'				=> '(saved)',

	// Play quiz
	'PLAY_QUIZ'						=> 'Play Quiz',
	'QUIZ_SAVE'						=> 'Save Quiz',
	'QUIZ_TIME_REMAINING'			=> 'Time remaining (seconds)',
	'QUIZ_NO_TYPE_SUBMIT'			=> 'This quiz was neither saved nor submitted',
	
	// Answers page
	'SHOW_RESULTS_INCORRECT'		=> 'You answered <strong>%s</strong><br />The correct answer was <strong>%s</strong>',
	'SHOW_RESULTS_CORRECT'			=> 'You correctly answered <strong>%s</strong>',
	'TIME_SUMMARY'					=> 'You completed the quiz in <strong>%d</strong> seconds',
	'RESULTS_SUMMARY'				=> 'Correct answers: <strong>%d</strong><br />Incorrect answers: <strong>%d</strong>',
	'QUIZ_POINTS_CASH_SUMMARY_WON'		=> 'You won <strong>%s points</strong> in this quiz.',
	'QUIZ_POINTS_CASH_SUMMARY_LOST'		=> 'You lost <strong>%s points</strong> in this quiz.',
	'QUIZ_RESULTS'					=> 'Quiz results',
	'QUIZ_TIME_EXCEEDED'			=> 'You have exceeded the time limit permitted for this quiz. You took <strong>%d</strong> seconds. Your answers were not saved.',
	'QUIZ_PROGRESS_SAVED'			=> 'This quiz has been saved. You may resume it at a later date',
	'CHEATING_ATTEMPT'				=> 'You are seeing this error because one of several events might have occurred:<br /><br />- A cheating attempt may have been detected. You cannot leave a quiz and later re-enter it without going through the save process.<br />- You have tried to resubmit a quiz that you have exceeded the time limit on<br />- You have already played this quiz, and the admin does not allow multiple attempts.',
	'MULTIPLE_SUBMISSION'			=> 'It appears you have tried to submit this quiz multiple times.',
	'QUIZ_PLAY_ONCE_ONLY'			=> 'You may only submit a quiz once.<br />%sClick here to return to the quiz index.%s',

	// statistics
	'QUIZ_STATISTICS'				=> 'Quiz statistics',
	'QUIZ_PLAYER'					=> 'Quiz player',
	'QUIZ_CORRECT'					=> 'Correct',
	'QUIZ_INCORRECT'				=> 'Incorrect',
	'QUIZ_PERCENTAGE'				=> 'Percentage',

	// statistic module names
	'QUIZ_BEST_RESULTS_STATS'			=> 'Best results',
	'QUIZ_MOST_PLAYED_STATS'			=> 'Most played',
	'QUIZ_MOST_CORRECT_ANSWERS_STATS'	=> 'Most correct answers',
	// 'QUIZ_HIGH_PERCENT_ANSWERS_STATS'	=> 'Highest percentage of correct answers',

	// QUIZ_CP.PHP
	'QUIZ_CP'						=> 'Quiz Control Panel',
	'QUIZ_CP_LOWER'					=> 'Quiz control panel',

	'QUIZ_MOVE'						=> 'Move',
	'QUIZ_EDIT'						=> 'Edit',
	'QUIZ_DELETE'					=> 'Delete',

	'QUIZ_DELETE_ASK'				=> 'Delete this quiz',
	'QUIZ_DELETE_ASK_CONFIRM'		=> 'Are you sure you want to delete this quiz?',
	'QUIZ_DELETE_SUCCESSFUL'		=> 'The quiz has been removed from the database successfully.<br /><br />%sReturn to the quiz control panel page.%s',

	'QUIZ_MOVE_ASK'					=> 'Move this quiz',
	'QUIZ_MOVE_ASK_CONFIRM'			=> 'Which category do you want to move the quiz to? Once you are ready to move the quiz, press submit. The category it currently in is: <strong>%s</strong>',
	'QUIZ_MOVE_TO'					=> 'Move from <strong>%s</strong> to:',
	'QUIZ_MOVE_SUCCESSFUL'			=> 'The quiz has been moved successfully.<br /><br />%sReturn to the quiz control panel page.%s',
	'QUIZ_MOVE_UNSUCCESSFUL'		=> 'You have not selected a category. Please click the back button in your browser to return to the previous page.',

	'QUIZ_EDIT_ASK'					=> 'Edit this quiz',
	'QUIZ_EDIT_ASK_CONFIRM'			=> 'Edit the options below and click submit once you are finished. Don\'t forget to check the box next to correct answer.',
	'QUIZ_EDIT_SUCCESSFUL'			=> 'The quiz has been successfully edited.<br /><br />%sReturn to the quiz control panel page.%s',

	// ACP
	'ACP_QUIZ' 			=> 'Quiz Admin',
	'ACP_QUIZ_INDEX_TITLE'	=> 'Quiz Admin',
	'ACP_QUIZ_CATEGORY'		=> 'Quiz Categories',
	'ACP_QUIZ_NEW_CATEGORY'		=> 'Create new Quiz Category',
	'ACP_DELETE_QUIZ_CATEGORY'	=> 'Delete quiz category',
	'ACP_DELETE_QUIZ_CATEGORY_EXPLAIN'	=> 'Select which new category you would like all of the quizzes to be moved into. No quizzes will be deleted, to delete quizzes you must go to the Quiz Control Panel.',

	'QUIZ_CATEGORY_LEGEND'		=> 'Quiz categories',
	'QUIZ_CATEGORY_CHANGE_LEGEND'	=> 'Edit',
	'QUIZ_ADD_NEW_CATEGORY'		=> 'Add new category',
	'QUIZ_CHANGE_CAT_NAME'		=> 'Category name',
	'QUIZ_CHANGE_CAT_DESC'		=> 'Category description',

	'QUIZ_SETTINGS_LEGEND'		=> 'Quiz settings',

	'QUIZ_CANNOT_MIN_MAX_SWITCH'	=> 'You cannot have a minimum number of questions that is higher than the maximum. Please go back and fix this.',
	'QUIZ_CANNOT_LOW_MAX'			=> 'You need to have at least 2 multiple choices. Please go back and fix this.',
	'QUIZ_CANNOT_DELETE_CATEGORY'	=> 'The category could not be deleted and the quizzes could not be moved. There could be two reasons for this:<br />1. You didn\'t select a new category for the quizzes to be moved to.<br />2. You selected the same category that will be deleted.<br /><br />Please go back and fix this.',

	'QUIZ_SUBMIT_MIN_SETTING'		=> 'Minimum number of questions',
	'QUIZ_SUBMIT_MIN_EXPLAIN'		=> 'The minimum number of questions allowed when submitting a quiz.',
	'QUIZ_SUBMIT_MAX_SETTING'		=> 'Maximum number of questions',
	'QUIZ_SUBMIT_MAX_EXPLAIN'		=> 'The maximum number of questions allowed when submitting a quiz.',
	'QUIZ_SUBMIT_MAX_MULTIPLE_CHOICE_SETTING'	=> 'Maximum number of choices',
	'QUIZ_SUBMIT_MAX_MULTIPLE_CHOICE_SETTING_EXPLAIN'	=> 'The maximum number of choices allowed in multiple choice questions.',	
	'QUIZ_SAVED_ENABLED_SETTING'	=> 'Allow saved quizzes',
	'QUIZ_SAVED_ENABLED_SETTING_EXPLAIN'	=> 'Can users save quizzes and resume them later?',	
	'QUIZ_PLAY_ONCE_SETTING'	=> 'Users can only play a quiz once',
	'QUIZ_PLAY_ONCE_EXPLAIN'	=> 'Setting this to yes means that a user can only complete a quiz once. It does not stop users from saving the quiz and returning, if that feature has been enabled.',	
	'QUIZ_SHOW_ANSWERS_SETTING'			=> 'Show answers',
	'QUIZ_SHOW_ANSWERS_SETTING_EXPLAIN'	=> 'Should users be shown the correct answers?',
	'QUIZ_TIME_LIMIT_PER_QUESTION_SETTING'			=> 'Time limit per question',
	'QUIZ_TIME_LIMIT_PER_QUESTION_SETTING_EXPLAIN'	=> 'How long do users have to answer each question? 0 to disable.',	
	'QUIZ_SHOW_HOW_MANY_STATS_SETTING'			=> 'Statistics lists',
	'QUIZ_SHOW_HOW_MANY_STATS_SETTING_EXPLAIN'	=> 'How many results for each statistics list should be shown?',		
	'QUIZ_USER_EDIT_OWN_QUIZ_SETTING'			=> 'Edit own quiz',
	'QUIZ_USER_EDIT_OWN_QUIZ_SETTING_EXPLAIN'	=> 'Can users edit/move/delete their own quizzes?',	
	'QUIZ_CASH_ON'			=> 'Turn on points compatibility.',
	'QUIZ_CASH_ON_EXPLAIN'	=> 'By turning on this functionality you will allow users to win and lose points when playing quizzes. Turning this feature on will display further cash options once you submit this configuration update.',	
	'QUIZ_CASH_WIN'	=> 'How many points for each correct answer?',
	'QUIZ_CASH_LOSE'	=> 'How many points lost for each incorrect answer?',

	'QUIZ_CATEGORY_ADDED_SUCESSFULLY'	=> 'The category was added successfully.',
	'QUIZ_CATEGORY_EDITED_SUCESSFULLY'	=> 'The category has been edited and updated successfully',
	'QUIZ_CONFIG_CHANGED_SUCESSFULLY'	=> 'Quiz configuration settings updated successfully.',
	'QUIZ_CATEGORY_DELETED_SUCCESSFULLY'	=> 'The category has been deleted successfully. The quizzes have been moved to the new category successfully.',
));

?>